/// <reference types="@webgpu/types" />
import { GridContextProps } from './GridContext';
import { GridShaderMode } from './GridShaderMode';
import { CanvasContextType } from './CanvasContext';
export declare class RenderBundleBuilder {
    private canvasContext;
    private device;
    private textureFormat;
    private gpuCanvasContext;
    private bindGroup;
    private f32UniformBufferSource;
    private u32UniformBufferSource;
    private drawIndirectBufferSource;
    private vertexBuffer;
    private f32UniformBuffer;
    private u32UniformBuffer;
    private viewportStateStorage;
    private gridDataBufferStorage;
    private focusedCellPositionStorage;
    private selectedStateStorage;
    private drawIndirectBuffer;
    private columnFocusRenderBundle;
    private rowFocusRenderBundle;
    private bodyRenderBundle;
    private viewportShadowRenderBundle;
    private topHeaderRenderBundle;
    private leftHeaderRenderBundle;
    private scrollBarBackgroundRenderBundle;
    private scrollBarBodyRenderBundle;
    constructor(mode: GridShaderMode, device: GPUDevice, textureFormat: GPUTextureFormat, gpuCanvasContext: GPUCanvasContext, canvasContext: CanvasContextType, texture: GPUTexture, gridSize: {
        numColumns: number;
        numRows: number;
    }, numViewports: number);
    updateF32UniformBuffer(gridContext: GridContextProps, overscroll: {
        x: number;
        y: number;
    }): void;
    updateViewportStateStorage(viewportStates: Float32Array): void;
    updateU32UniformBuffer(gridContext: GridContextProps, numCellsToShow: {
        numColumnsToShow: number;
        numRowsToShow: number;
    }, scrollBarState: number, index: number): void;
    updateDataBufferStorage(data: Float32Array | Uint32Array): void;
    updateFocusedCellPositionStorage(focusedCellPosition: Uint32Array): void;
    updateSelectedStateStorage(selectedState: Uint32Array): void;
    private createBindGroup;
    private createRenderBundle;
    updateDrawIndirectBuffer(numColumnsToShow: number, numRowsToShow: number, numViewports: number): void;
    private createBodyRenderBundle;
    private createViewportShadowRenderBundle;
    private createColumnFocusRenderBundle;
    private createRowFocusRenderBundle;
    private createTopHeaderRenderBundle;
    private createLeftHeaderRenderBundle;
    private createScrollBarBackgroundRenderBundle;
    private createScrollBarBodyRenderBundle;
    createCommandBuffer(): GPUCommandBuffer;
    execute(): void;
}
